#! /usr/bin/perl -CS
use lib '/var/www/vhosts/fa-technik.adfc.de/httpdocs/cgi-bin/perl5';
#print "\@INC is @INC\n";
#no UTF8;
#use strict;
use warnings;
use Encode;
use CGI;
use CGI::Pretty;
use CGI qw/:standard -$check *table *Tr *form *html *blockquote/ ;
#use CGI qw/:standard  *table *Tr *form *html *blockquote/ ;

$CGI::POST_MAX=1024 *100;	# max 100 KB uploads

#use locale;
#use encoding "latin1";
#use encoding UTF8;
use lib('/var/www/vhosts/fa-technik.adfc.de/httpdocs/cgi-bin/lib/');
use utf8;
use Encode::utf8;
use URI::Encode

@list = Encode->encodings();

my $dpath       = "opengeodb";
my $dnewfile    = "$dpath/new.tab";
my $logfile     = "$dpath/opengeodb.log";
my $commandfile = "$dpath/changes.sql";
my $htmlfile    = "$dpath/changes.html";
my $lfile       = "ags/o.log";
my $job	        = "search";
my $check       = 0;
my $var         = 0;
my $i           = 0;
my $country     ="DE";
my $earth=6380; # radius for Europe


my (@locid,@kz,@name,@ort,@plz,@vorwahl,@lat,@lon,@amt,@typ);
my (@einwohner,@flaeche,@level,@of,@invalid,@distance);
my @extra;
my ($land);
my ($html_style, $html_header, $html_footer);
my ($hu, $he, $hp); # human user, e-mail, pass
my ($ckhu, $ckhe, $ckhp); # human user, e-mail, pass
init();
#report_error();
#report_use();

#print start_html('opengeodb');

print $hu?header(-cookies=>[$ckhu,$ckhe],-charset => 'UTF-8'):header(-charset => 'UTF-8');
print $html_style;
print $html_header;


print "RC:".raw_cookie(),p if $check;
print "QS: ".query_string,p if $check;
print "URL: ".url(),p if $check;
print Dump if $check;
$ört = "Öhringen";
#$ort = decode_utf8(param('ort'));
#param('ort', $ort); # fix the encoding!
#print ">$ort<";
#search_form();
my $xx= param('x');
my $xxx  = decode(utf8=>param('x'));
print hr(),  start_table();
print Tr(th({align=>"RIGHT"}, "Ort:"),	th($ört), td(i(edit_url($locid[0],'Ort',$ört))));
#    td(i("<a href=\"?locid=$locid[0];c=$country;action=delete\">delete</a>")));
#        td(i("delete")));
#        print Tr(th({align=>"RIGHT"}, "Ort:"),  th($ort[0]), td(i(edit_url($locid[0],'Ort',$ort[0]))));
#
    print "<tr style=\"$background\">";
    print td($my_level, a({-href=>"?locid=$locid[$ii];c=$country"}, $ört));
    print "</tr>\n";
    print Tr(td("param x", param('x'),$xx,$xxx));
    print Tr(td("is_utf x"),td( Encode::is_utf8(param('x'))),td(Encode::is_utf8($xx)),td(Encode::is_utf8($xxx)));


print @list,$list;
print end_table();

print $html_footer, end_html(),"\n";
# ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #
sub results {
my $ii=0;
my $my_plz;
my $my_level;
my $background="background-color: rgb(255, 255, 102);";


print hr(), start_table();
print "<tr style=\"$background\">".th(["<","loc_id","AGS", "Ort", "lat / lon"]);
print param("distance")?th("distance"):th("PLZ");
print th(">"),"</tr>\n";
while ($ii < $i) {
    $background= (int($ii/2) == int(($ii+1)/2))?"background-color: rgb(204, 204, 204);":"";
    print "<tr style=\"$background\">";
    print td(a({-href=>"?locid=$of[$ii];c=$country"},"<"));
    print td(a({-href=>"?locid=$locid[$ii];c=$country"},$locid[$ii]));
    print td($ags[$ii]);
    $my_level = "&nbsp;" x $level[$ii];
    print td($my_level, a({-href=>"?locid=$locid[$ii];c=$country"}, $ort[$ii]));
    $lon[$ii]?
        printf("<td align=right>%.4f / %.4f</td>", $lat[$ii], $lon[$ii])
        :print td();
    if (param("distance")) {
    	printf ("<td align=right>%0.1f km</td>", $distance[$ii]);
    } else {
        $my_plz = ($plz[$ii]=~ /^(.{17}.)/)?$1."...":$plz[$ii];
        $my_plz =~ s//, /g;
        $my_plz =~ s/ *, */, /g;
        print td($my_plz);
    }
    print td(a({-href=>"?parts=$locid[$ii];c=$country"},">"));
    print "</tr>";
    $ii++;
}

print end_table();
return '';
}
# ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #
sub edit_url {
my ($locid, $field, $value) = @_;
my %geodb = (
'Amtlicher Gemeindeschlüssel'	=> '500600000',
'AGS'	=> '500600000',
'Amt'	=> '100550000',
'Auf 10 Jahre genaues Datum'	=> '300400000',
'Auf ein Jahr genaues Datum'	=> '300300000',
'beliebig'	=> '1',
'Bundesland'	=> '100300000',
'Durchschnittliche Höhe'	=> '650800003',
'Ebene'	=> '400200000',
'Einwohnerzahl'	=> '600700000',
'Einwohner'	=> '600700000',
'Erdteil'  	=> '100100000',
'Fläche'   	=> '610000000',
'Gemeindeschlüssel'	=> '500600000',
'Genaue Einwohnerzahl'	=> '650700002',
'Genaues Datum'	=> '300100000',
'Höhe am Referenzpunkt mit der angegebenen loc_id'	=> '650800004',
'Höhe an der angegebenen Koordinate'	=> '650800005',
'Höhenangabe'	=> '600800000',
'ISO 3166 Alpha-2'	=> '500100001',
'ISO_3166_2'	=> '500100003',
'Kanton'	=> '100300000',
'KFZ-Kennzeichen'	=> '500500000',
'KZ'	=> '500500000',
'Landkreis'	=> '100500000',
'lat'	=> '200200000',
'level'	=> '400200000',
'lon'	=> '200300000',
'Maximale Höhe'	=> '650800001',
'Minimale Höhe'	=> '650800002',
'Name'	=> '500100000',
'of'	=> '400100000',
'Ort'	=> '500100000',
'nicht vorhanden'	=> '0',
'Ortschaft'	=> '100700000',
'Gemeinde'	=> '100600000',
'Politische Gliederung'	=> '100600000',
'PLZ'	=> '500300000',
'Postleitzahl'	=> '500300000',
'Postleitzahlgebiet'	=> '100800000',
'Quelle'	=> '500800000',
'Regierungsbezirk'	=> '100400000',
'Region eines Postleitzahlgebietes'	=> '500100004',
'ASCII'	=> '500100002',
'Sortiername'	=> '500100002',
'Sortiername eines Verwaltungszusammenschlusses'	=> '500700001',
'Staat/Land'	=> '100200000',
'Land'	=> '100200000',
'Staat'	=> '100200000',
'Teil von'	=> '400100000',
'Telefonvorwahl'   => '500400000',
'Typ'	=> '400300000',
'type'	=> '400300000',
'[unbekannt]'	=> '-1',
'Unbekanntes Datum in der Zukunft'	=> '300500000',
'Ungefähre Einwohnerzahl'	=> '650700001',
'Verwaltungszusammenschluss'	=> '500700000',
'Verwaltungsgemeinschaft'	=> '100550000',
'von'	=> '400100000',
'Vorwahl'   => '500400000',
'WGS84 Koordinaten'	=> "200100000");
$value ="---" if !$value;
my $url = "<a href=\"?locid=$locid;f=$geodb{$field};v=$value;c=$country\">edit</a>";
return($url);
}
# ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #
sub tab2sql {
my $i=0;
my $ii=0;
my @data;
my ($locid, $ags, $name, $ort, $lat, $lon, 
	$amt, $plz, $vorwahl,$einwohner, $flaeche, $kz, 
	$typ, $level, $of, $invalid);
my $command;

open (DFILE, "<:utf8", "$dpath/$country.tab") 
    or die "datafile not available: $dpath/$country.tab\n",p;
if (<DFILE> and /^[^#]/)  { # skip first header line
    $data[0] = $_;
    $i=1;
}
while (<DFILE>) {
    $data[$i] = $_;
    $i++;
}
close (DFILE);
open (DFILE, ">:utf8", "$dpath/$country.sql") 
    or die "datafile not available: $dpath/$country.sql\n",p;
while ($ii < $i){
	$data[$ii]=~ s/'/''/g;
    ($locid, $ags, $name, $ort, $lat, $lon, 
	$amt, $plz, $vorwahl,$einwohner, $flaeche, $kz, 
	$typ, $level, $of, $invalid) 
		=  (split /[\t\n\r]/, $data[$ii]);
	#	or print "malformatted input line:\n\t".$_."\n";
	$ii++;
	next if $invalid;
	print DFILE "INSERT INTO geodb_locations VALUES($locid,100".
        ($level?$level:8)."00000);\n";
    print DFILE "INSERT INTO geodb_coordinates VALUES($locid,200100000,".
        "$lat,$lon,null,null,null,'3000-01-01',300500000);\n" if $lat;
    print DFILE "INSERT INTO geodb_textdata VALUES($locid,400100000,".
        "'$of',null,null,null,null,null,'3000-01-01',300500000);\n" if $of;
    print DFILE "INSERT INTO geodb_textdata VALUES($locid,400200000,".
        "'$level',null,null,null,null,null,'3000-01-01',300500000);\n" if $level;
    print DFILE "INSERT INTO geodb_textdata VALUES($locid,400300000,".
        "'$typ','de',1,1,null,null,'3000-01-01',300500000);\n" if $typ;
    print DFILE "INSERT INTO geodb_textdata VALUES($locid,500100000,".
        "'$ort','de',1,1,null,null,'3000-01-01',300500000);\n" if $ort;
    print DFILE "INSERT INTO geodb_textdata VALUES($locid,500100002,".
        "'$name','de',1,1,null,null,'3000-01-01',300500000);\n" if $name;
	print DFILE "INSERT INTO geodb_textdata VALUES($locid,500400000,".
        "'$vorwahl',null,null,null,null,null,'3000-01-01',300500000);\n" if $vorwahl;
	print DFILE "INSERT INTO geodb_textdata VALUES($locid,500500000,".
	    "'$kz',null,null,null,null,null,'3000-01-01',300500000);\n" if $kz;
    print DFILE "INSERT INTO geodb_textdata VALUES($locid,500600000,".
        "'$ags',null,null,null,null,null,'3000-01-01',300500000);\n" if $ags;	
    print DFILE "INSERT INTO geodb_textdata VALUES($locid,500700000,".
        "'$amt','de',1,1,null,null,'3000-01-01',300500000);\n" if $amt;
    foreach $my_plz (split /,/, $plz) {
      print DFILE "INSERT INTO geodb_textdata VALUES($locid,500300000,".
        "'$my_plz',null,null,null,null,null,'3000-01-01',300500000);\n";}
	print DFILE "INSERT INTO geodb_intdata  VALUES($locid,600700000,".
        "$einwohner,null,null,'3000-01-01',300500000);\n"if $einwohner;
	print DFILE "INSERT INTO geodb_floatdata  VALUES($locid,610000000,".
	    "$flaeche,null,null,'3000-01-01',300500000);\n"if $flaeche;
}
close (DFILE);
}
# ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #
sub update_new {
my @sqlcommand;
my @htmlcommand;
my ($i, $ii);
my @new_error;
my $error_count=0;
my ($lat, $lon);
my $flaeche;

$lat = param(200200000);
$lat =~ s/^(.*),([^\.]*)$/$1.$2/;
$lon = param(200300000);
$lon =~ s/^(.*),([^\.]*)$/$1.$2/;
$flaeche =~ param(610000000);
$flaeche =~ s/^(.*),([^\.]*)$/$1.$2/;

$locid=locid_new($locid);
print b("update_new:$locid"),p if $check;
#Ebene
if(param(400200000)){
    $command[0]="INSERT INTO geodb_locations VALUES($locid,100".
        param(400200000)."00000);";
    $command[10]="INSERT INTO geodb_textdata VALUES($locid,400200000,'".
        param(400200000)."',null,null,null,null,null,'3000-01-01',300500000);";
} else {
    $new_error[0]="Es fehlt eine gültige Hierarchie-Ebene!"; 
    $error_count++;
}

#Name
if(param(500100000)){
    $command[1]="INSERT INTO geodb_textdata VALUES($locid,500100000,'".
        param(500100000)."','de',1,1,null,null,'3000-01-01',300500000);";
    $command[11]="INSERT INTO geodb_textdata VALUES($locid,500100002,'".
        search_term(param(500100000))."','de',1,1,null,null,'3000-01-01',300500000);";
} else {
    $new_error[1]="Eine Namensangabe ist erforderlich!"; 
    $error_count++;
}
#lat/lon
if($lat and $lon) {
    $command[2]="INSERT INTO geodb_coordinates VALUES($locid,200100000,".
    $lat.",".$lon.",null,null,null,'3000-01-01',300500000);";
} else {
    if (param(200200000)) { 
        $new_error[2] = "Bitte geben Sie den Breitengrad (lat) an!"; 
    } elsif (param(200300000)) {
        $new_error[2] = "Bitte geben Sie den Längengrad (lon) an!"; 
    } else {
        $new_error[2] = "Bitte geben Sie Breiten- und Längengrad (lat, lon) an!"; 
    }
    $error_count++;
}
#AGS
if(param(500600000)){
    $command[12]="INSERT INTO geodb_textdata VALUES($locid,500600000,'".
        param(500600000)."',null,null,null,null,null,'3000-01-01',300500000);";
} else {
    $new_error[12]="Bis zur Gemeindeebene sollte ein Gemeindeschlüssel vergeben werden!"
        if param(400200000)<7; 
    $error_count++;
}
#Teil von
if(param(400100000)){
    $command[3]="INSERT INTO geodb_textdata VALUES($locid,400100000,'".
        param(400100000)."',null,null,null,null,null,'3000-01-01',300500000);";
} else {
    $new_error[3]="Bitte prüfen Sie, welche loc_id übergeordnet ist!"; 
    $error_count++;
}
#Typ
if(param(400300000)){
    $command[4]="INSERT INTO geodb_textdata VALUES($locid,400300000,'".
        param(400300000)."','de',1,1,null,null,'3000-01-01',300500000);";
} 
# Amt
if(param(500700000)){
    $command[5]="INSERT INTO geodb_textdata VALUES($locid,500700000,'".
        param(500700000)."','de',1,1,null,null,'3000-01-01',300500000);";
    $new_error[5]="Verwaltungsgemeinschaften sind nur auf Gemeindeebene relevant.";
} 
# Einwohnerzahl
if(param(600700000)){
    $command[6]="INSERT INTO geodb_intdata  VALUES($locid,600700000,".
        param(600700000).",null,null,'3000-01-01',300500000);";
} 
# Fläche
if(param(610000000)){
    $command[7]="INSERT INTO geodb_floatdata  VALUES($locid,610000000,".
        $flaeche.",null,null,'3000-01-01',300500000);";
} 
#KFZ-Kennzeichen
if(param(500500000)){
    $command[8]="INSERT INTO geodb_textdata VALUES($locid,500500000,'".
        param(500500000)."',null,null,null,null,null,'3000-01-01',300500000);";
} 
#Vorwahl
if(param(500400000)){
    $command[9]="INSERT INTO geodb_textdata VALUES($locid,500400000,'".
        param(500400000)."',null,null,null,null,null,'3000-01-01',300500000);";
} 
#'500300000' => 'Postleitzahl',
if(param(500300000)){
    $i=0;
    foreach $my_plz (split /,/, param(500300000)) {
      $command[11+$i] = "INSERT INTO geodb_textdata VALUES($locid,500300000,'".
        $my_plz . "',500300000,null,null,null,null,null,'3000-01-01',300500000);";
        $i++;
    }
}

### date ###
my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) =
                                                localtime(time());
my $date = ($year+1900)."-". sprintf("%02d", ($mon+1)) ."-".
	sprintf("%02d", $mday) . 
	sprintf(" %02d:%02d",$hour,$min);

$i=0;
open (SQLFILE, ">>:utf8", $commandfile);
print $command[0],"\n",p;
while($i <= 13+(param(500300000)=~tr/,//)) {
    print SQLFILE "$command[$i] # $date \n" if $command[$i]; 
    print "$command[$i] # $date $hu\n",br if $command[$i];
    print br,b($new_error[$i]) ."\n",p if $new_error[$i];
    $i++;}
close (SQLFILE);
### change log ###
my $hl = "<a href=\"?by=$hu\">$hu</a>" if $hu;
$command = query_string;
$command =~ s/\d+=;//g;
$command =~ s/(\D+=[^;]*;*)//g;
$command =~ s/;/<BR>/g;
$command = "<tr>".
    "<td valign=top>".
        "<a href=\"opengeodb.pl?locid=$locid;c=$country\">$locid</a></td>".
    "<td valign=top>".param(500100000)."</td>".
    "<td valign=top>neu</td>".
    "<td valign=top colspan=2>$command</td>".
    "<td valign=top>$date</td>".
    "<td valign=top>$hl</td>".
    "<td valign=top>".
        "<a href=\"?locid=$locid;c=$country;action=delete\"><i>delete</i></a>".
        "</td></tr>";
print table(Tr(th(["locid", "Name", "Feld", "alt", "neu", "Datum",""]),
    th("&nbsp;")), $command);
open (HTMLFILE, ">>:utf8",$htmlfile);
print HTMLFILE $command, "\n";
close (HTMLFILE);
$command = param(500100002)?param(500100002):search_term(param(500100000));
$command = "$locid\t".
    param(500600000)."\t". 
    $command."\t".
    param(500100000)."\t".
    $lat ."\t".
    $lon ."\t".
    param(500700000)."\t".
    param(500300000)."\t".
    param(500400000)."\t".
    param(600700000)."\t".
    $flaeche ."\t".
    param(500500000)."\t".
    param(400300000)."\t".
    param(400200000)."\t".
    param(400100000)."\t".
    "0\n"   ;

print $command if $check;
open (DFILE, ">>:utf8", "$dpath/$country.tab") 
    or print "datafile not available: $dpath/$country.tab\n",p;
print DFILE $command;
close (DFILE);
}
# ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #
sub update_data {
my ($country,$locid, $field, $old, $new) =@_;
my $command;
my $data;
my $i=0;
my $ii=0;

my %geodb_textdata = (
'200100000' => 'Koordinaten',
'200200000' => 'Breitengrad',
'200300000' => 'Längengrad',
'400100000' => 'Teil von',
'400200000' => 'Ebene',
'400300000' => 'Typ',
'500100000' => 'Name',
'500100001' => 'ISO 3166 Alpha-2',
'500100002' => 'Sortiername',
'500100003' => 'ISO_3166_2',
'500100004' => 'Region eines Postleitzahlgebietes',
'500300000' => 'Postleitzahl',
'500400000' => 'Vorwahl',
'500500000' => 'KFZ-Kennzeichen',
'500600000' => 'Amtlicher Gemeindeschlüssel',
'500700000' => 'Verwaltungszusammenschluss',
'500700001' => 'Sortiername eines Verwaltungszusammenschlusses',
'500800000' => 'Quelle');
my %geodb_intdata = (
'600700000' => 'Einwohnerzahl',
'600700001' => 'Ungefähre Einwohnerzahl',
'600700002' => 'Genaue Einwohnerzahl',
'610000000' => 'Fläche',
'650800000' => 'Höhenangabe',
'650800001' => 'Maximale Höhe',
'650800002' => 'Minimale Höhe',
'650800003' => 'Durchschnittliche Höhe',
'650800004' => 'Höhe am Referenzpunkt mit der angegebenen loc_id',
'650800005' => 'Höhe an der angegebenen Koordinate');

return 0 if $old eq $new;
$old = "" if $old eq "---";
$new = "" if $new eq "---";
$new =~ s/^\s+//;
$new =~ s/\s+$//;

if ($field eq '200200000') { # lat
    $new =~ s/^(.*),([^\.]*)$/$1.$2/;
    $command = 'INSERT INTO geodb_coordinates VALUES(' . $locid .
        ',200200000,' . $new . ',' . $lat[0] . 
        ',null,null,null,\'3000-01-01\',300500000);'; 
    $lon[0] = $new;
} elsif ($field eq '200300000') { # lat
    $new =~ s/^(.*),([^\.]*)$/$1.$2/;
    $command = 'INSERT INTO geodb_coordinates VALUES(' . $locid .
        ',200300000,' . $lon[0] . ',' . $new . 
        ',null,null,null,\'3000-01-01\',300500000);';    
    $lat[0] = $new;
} elsif ($geodb_textdata{$field}) {
    $command = 'INSERT INTO geodb_textdata VALUES('. $locid.
        ",". $field .',"' . $new . '",' .  
        '\'de\',1,1,null,null,\'3000-01-01\',0);';
    $of[0]          = $new if $field eq 400100000;
    $level[0]       = $new if $field eq 400200000;
    $typ[0]         = $new if $field eq 400300000;
    $ort[0]         = $new if $field eq 500100000;
    $name[0]        = $new if $field eq 500100002;
    $vorwahl[0]     = $new if $field eq 500400000;
    $kz[0]          = $new if $field eq 500500000;
    $ags[0]         = $new if $field eq 500600000;
    $amt[0]         = $new if $field eq 500700000;
    
    if ($field eq 500300000) {
        #print "plz1: ",$plz[0],"\n",p;

        if (!$new) {
            $plz[0] = ','. $plz[0] .',';
            $plz[0] =~ s/,$old,/,/g;
            $plz[0] =~ s/,+/,/g;            
            $plz[0] =~ s/^,*(.*),*$/$1/;        
        } elsif ($plz[0] =~ /$new/) { 
            print  sort_plz (split /,/, $plz[0]) if $check;
            $plz[0] = delist(sort sort_plz (split /,/, $plz[0]));

        } else { 
	    $new =~ s/[^\d,]*//g;
            $plz[0] = delist(sort (split /,/, "$plz[0],$new"));
        }
        # print "plz2: ",$plz[0],"\n",p;
    }
    
} elsif ($geodb_intdata{$field}) {
    $command = 'INSERT INTO geodb_intdata  VALUES('. $locid.
        ',' . $field . ',' . $new .  
        ',null,null,\'3000-01-01\',300500000);';
    $einwohner[0]   = $new if $field eq 600700000;
    $new =~ s/^(.*),([^\.]*)$/$1.$2/;
    $flaeche[0]     = $new if $field eq 610000000;
} else {
    $command = 'INSERT INTO geodb_textdata VALUES('. $locid.
        ','. $field . ',"' . $new . '",' .
        '\'de\',1,1,null,null,\'3000-01-01\',0);';
    print b("unbekannter Feldtyp: $field"),p;
}

### date ###
my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) =
                                                localtime(time());
my $date = ($year+1900)."-". sprintf("%02d", ($mon+1)) ."-".
        sprintf("%02d", $mday) .  
        sprintf(" %02d:%02d",$hour,$min); 


### SQL-commands ###
print "SQL-Befehl:\n",p;
print $command."\n # $date\n",p;
open (SQLFILE, ">>:utf8", $commandfile);
print SQLFILE "$command # $date $country\n";
close (SQLFILE);

### change log ###
$command = "<tr><td><a href=\"?locid=$locid[$ii];c=$country\">$locid[$ii]</a></td>".
        "<td>$ort[0]</td>";
if($geodb_textdata{$field}) {
    $command = $command."<td>$field ($geodb_textdata{$field})</td>".
        "<td>\"$old\"</td><td>\"$new\"</td><td>$date</td>";
} elsif ($geodb_intdata{$field}) {
    $command = $command."<td>$field ($geodb_intdata{$field})</td>".
        "<td>$old</td><td>$new</td><td>$date</td>";
} else {
    $command = $command."<td>$field</td><td>$old</td><td>$new</td><td>$date</td>";
}
$new="---" if !$new;
$old="---" if !$old;
$command = $command."<td><a href=\"?c=$country;locid=$locid;f=$field;v=$new;n=$old\">".
    "<i>undo</i></a></td></tr>";
print table(Tr(th(["loc_id","Name","Feld","alt","neu","Datum","&nbsp;"])), $command);
open (HTMLFILE, ">>:utf8",$htmlfile);
print HTMLFILE $command, "\n";
close (HTMLFILE);


### lock and update tab file ###
my $locked = 1;
while ($locked) {
    open (LOCKFILE, "<:utf8", $dpath.'/.'.$country.'.lock');
        if (<LOCKFILE> > time()-100) {
            print time(), ": waiting for unlock\n",p;
            sleep 10;
        } else {
            close (LOCKFILE);
            open (LOCKFILE, ">:utf8", $dpath.'/.'.$country.'.lock');
            print LOCKFILE time();
            print $country.".lock: ",time(),"\n",p if $check;
            $locked=0;
        }
    close (LOCKFILE);
}

open (DFILE, "<:utf8", $dpath.'/'.$country.'.tab') 
    or die "datafile not available: $dpath/$country.tab\n",p;
while (<DFILE>) {
    if (/^$locid\t/) {
        $data[$i] = $locid[0]. "\t" .$ags[0]. "\t" .$name[0]. "\t" .$ort[0]. "\t" .
            $lat[0]. "\t" .$lon[0]. "\t" .$amt[0]. "\t" .$plz[0]. "\t" .
            $vorwahl[0] . "\t" . $einwohner[0]. "\t" . $flaeche[0] . "\t" . $kz[0]. "\t" . 
            $typ[0]. "\t" .$level[0]. "\t" .$of[0]. "\t" .$invalid[0] . "\n"; 
    } else {
        $data[$i]=$_;
    }
    $i = $i+1;
}
close (DFILE);
#print "$i lines read\n",p;

open (DFILE, ">:utf8", $dpath.'/.'.$country.'.tab') or die "datafile not writable\n",p;
while ($ii <= $i) {
    print DFILE $data[$ii];
    $ii = $ii+1;
}
close (DFILE);
#print ($ii-1) . ' lines written\n',p;


rename $dpath.'/'.$country.'.tab', $dpath.'/.'.$country.'.bkup';
rename $dpath.'/.'.$country.'.tab', $dpath.'/'.$country.'.tab';
unlink $dpath.'/.'.$country.'.lock';
}
# ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #
sub delete_locid {
my ($country,$locid, $action) =@_;
my @line;

### lock and update tab file ###
my $locked = 1;
while ($locked) {
    open (LOCKFILE, "<:utf8", $dpath.'/.'.$country.'.lock');
        if (<LOCKFILE> > time()-100) {
            print time(), ": waiting for unlock\n",p;
            sleep 10;
        } else {
            close (LOCKFILE);
            open (LOCKFILE, ">:utf8", $dpath.'/.'.$country.'.lock');
            print LOCKFILE time();
            print $country.".lock: ",time(),"\n",p if $check;
            $locked=0;
        }
    close (LOCKFILE);
}

open (DFILE, "<:utf8", $dpath.'/'.$country.'.tab') 
    or die "datafile not available: $dpath/$country.tab\n",p;
while (<DFILE>) {
    if (/^$locid\t/) {
	(@line) = split /[\t\n]/, $_;
	$action eq "delete"?
		splice (@line, 15, 1, "1") :
		splice (@line, 15, 1, "0") ; # add invalid tag
	$data[$i]= join ("\t", @line)."\n";
    } else {
        $data[$i]=$_;
    }
    $i++;
} 
close (DFILE);
#print "$i lines read\n",p;

open (DFILE, ">:utf8", $dpath.'/.'.$country.'.tab') or die "datafile not writable\n",p;
while ($ii <= $i) {
    print DFILE $data[$ii];
    $ii = $ii+1;
}
close (DFILE);
#print ($ii-1) . ' lines written\n',p;


rename $dpath.'/'.$country.'.tab', $dpath.'/.'.$country.'.bkup';
rename $dpath.'/.'.$country.'.tab', $dpath.'/'.$country.'.tab';
unlink $dpath.'/.'.$country.'.lock';
}
# ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #
sub get_user {
my ($url)= @_;
print "Das Rücksetzen und Löschen ist nur für angemeldete Benutzer möglich. ".
    "Bitte geben Sie daher einen Benutzernamen und Ihre E-Mail-Adresse an.";

print start_form;

print start_table({-border=>'0'});
print Tr(), td(b('Benutzer')), td(textfield('hu'));
print Tr(), td(b('E-Mail')), td(textfield('he'));
print Tr(td,td(submit(-name=>'registrieren')));
print hidden(-name=>'c',-value=>param("c")) if param("c");
print hidden(-name=>'n',-value=>param("n")) if param("n");
print hidden(-name=>'f',-value=>param("f")) if param("f");
print hidden(-name=>'v',-value=>param("v")) if param("v");
print hidden(-name=>'locid',-value=>param("locid")) if param("locid");
print hidden(-name=>'action',-value=>param("action")) if param("action");

print end_table();
print end_form();
}
# ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #
sub sort_plz {$a <=> $b}
# ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #
sub delist {
my @list = @_;
my $item;
my $string;
foreach $item (@list) {
    $string = "$string,$item";
    print "$item\n" if $check;
}
print "before:$string\n" if $check;
$string =~ s/^,*(.*),*$/$1/;
print "after:$string\n" if $check;
return ($string);
}
# ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #
sub edit_search {
my ($country, $locid, $field, $old) =@_;
my $new;

print start_form(-accept-charset=>"utf-8");
print hidden(-name=>'c',-value=>$country);
print hidden(-name=>'locid',-value=>$locid);
print hidden(-name=>'f',-value=>$field);
print hidden(-name=>'v',-value=>$old);

$old="" if $old eq "---";
print start_table({-border=>'0'});
print Tr(th({align=>"RIGHT"}, "loc_id:"),	th($locid));
print Tr(th({align=>"RIGHT"}, "alter Wert:"),	td($old));
print Tr(th({align=>"RIGHT"}, "neuer Wert:"),	
    td(textfield(-name => 'n', -default => $old)));


print	Tr(td,td(submit(-name=>'ändern')));

print end_table();
print end_form();

}
# ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #
sub locid_new {
my ($newid)=@_;
my @logdata;
my $i=0;
my $ii=0;

print ">newid:$newid<\n",br if $check;

# get max. newid
$i=0;
open (LOGFILE, "<:utf8", $logfile) or print "could not open logfile $logfile for reading\n";
while (<LOGFILE>) {
    $logdata[$i] = $_;
    if (/max_id\t(\d+)/) {
		$ii = $1;
		if ($newid == $ii) {
			$ii = $newid+1;	
        	$logdata[$i] =~ s/\t$newid$/\t$ii/;
		} else {
        	$newid = $ii+1;
        	$logdata[$i] =~ s/\t$ii$/\t$newid/;
    	}
	}
    $i++;
}
close (LOGFILE);

if (!($ii>11111)) { # take dummy range
    $newid =  55555;
    $logdata[$i] = "max_id\t555556";
    $i++;
}

$ii=0;
open (LOGFILE, ">:utf8", $logfile) or die "could not open logfile $logfile for writing\n";
while ($ii <= $i) {
    print LOGFILE $logdata[$ii];
    $ii++;
}
close (LOGFILE);

print ">newid:$newid<\n",br if $check;

return($newid);

}
# ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #
sub edit_new {
my $locid;
my $i;
my $ii;
my $of;
my $level=7;


$locid=locid_new(0);
$ii=7;
$ii=param(400200000)  if param(400200000);
$level = 
    '<select name="400200000">
<option value="1">Kontinent</option>
<option value="2">Staat</option>
<option value="3">Bundesland</option>
<option value="4">Regierungsbezirk</option>
<option value="5">Kreis</option>
<option value="6">Gemeinde</option>
<option value="7">Ort</option>
<option value="8">Ortsteil</option>
<option value="9">Strasse</option>
<option value="10">Einzelkoordinate</option>
</select>';
$level=~ s/(value="$ii")/selected="selected" $1/;
$of=param(400100000) if param(400100000);

print start_form;
print hidden(-name=>'locid',-value=>$locid);
print start_table({-border=>'0'});
print Tr(td(b('Land')),
	td(popup_menu(
		  -name=>'c',
                  -values=>{'DE'=>'Deutschland',
                            'AT'=>'Österreich',
                            'BE'=>'Belgien',
                            'CH'=>'Schweiz',
                            'LI'=>'Liechtenstein',
                            'LU'=>'Luxemburg'},
                  -default=>'D')));
print Tr(td(b('loc_id:')), th($locid), td("neu"));
print Tr(td(b('Ort:')), td(textfield('500100000')),td("erforderlich"));
#print Tr(), td(b('PLZ')), td(textfield('plz'));
print Tr(td(b('lat:')), td(textfield('200200000')),td("erforderlich"));
print Tr(td(b('lon:')), td(textfield('200300000')),td("erforderlich"));
print Tr(td(b('Ebene:')),td($level),td("erforderlich"));
print Tr(td(b('AGS:')), td(textfield('500600000')),td("erforderlich bis zur Gemeindeebene"));
print Tr(td(b('Teil von:')), 
    td(textfield(-name=>'400100000',
        -override=>1,
        -default=>$of)),td("erforderlich"));
print Tr(td(b('Typ:')), td(textfield('400300000')),td("&nbsp;"));
print Tr(td("&nbsp;"),td(hr()),td("&nbsp;"));
print Tr(td(b('Amt:')), td(textfield('500700000')),td("nur auf Gemeindeebene"));
# print Tr(td(b('ASCII:')), td(textfield('500100002')),td("zum Suchen/Sortieren"));
print Tr(td(b('Einwohner:')), td(textfield('600700000')),td("aktuellster Wert"));
print Tr(td(b('Fläche:')), td(textfield('610000000')),td("in Quadratkilometern"));
print Tr(td(b('Kennzeichen:')), td(textfield('500500000')),td("Kfz-Kennzeichen"));
print Tr(td(b('PLZ:')), td(textfield('500300000')),td("kommagetrennte Liste"));
print Tr(td(b('Vorwahl:')), td(textfield('500400000')),td("&nbsp;"));

print end_table();
print	Tr(td,td(submit(-name=>'neu')));
print end_form();

return(1);
}

# ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #
sub search_form {
print start_form;

print start_table({-border=>'0'});
print 	start_Tr(), td(b('Land')),
	td(popup_menu(-name=>'c',
                  -values=>{'DE'=>'Deutschland',
                            'AT'=>'Österreich',
                            'BE'=>'Belgien',
                            'CH'=>'Schweiz',
                            'LI'=>'Liechtenstein',
                            'LU'=>'Luxemburg'},
                  -default=>'D')),
	end_Tr();
print Tr(td(b('Ort')), td(textfield('ort')));
#print Tr(td(b('PLZ')), td(textfield('plz')));
print	Tr(td,td(submit(-name=>'suchen')," ",defaults(-name=>'delete')));

print end_table();
print end_form();

}
# ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #
sub search_all {
my ($country, $ort) = @_;
my $dfile = $dpath."/".$country.".tab";

#$ort = search_term($ort);

open (KEYD, "<:utf8", $dfile) or die "can not open $dfile\n";

$i = 0;
if (<KEYD> and /^[^#]/)  { # skip first header line
    $data[0] = $_;
    $i=1;
}

while(<KEYD>){
	next if !/$ort/i;
	($locid[$i], $ags[$i], $name[$i], $ort[$i], $lat[$i], $lon[$i], 
	$amt[$i], $plz[$i], $vorwahl[$i],$einwohner[$i], $flaeche[$i], $kz[$i], 
	$typ[$i], $level[$i], $of[$i], $invalid[$i]) 
		= split /[\t\n]/;
	#	or print "malformatted input line:\n\t".$_."\n";
	$i++;
	if ($i>100) {
	   print "Abbruch der Suche nach $ort nach 100 Treffern\n",p;
	   last; }
}
	print $i . "\t" . $locid[$i-1]."\t" 
	    . $ags[$i-1]."\t". $name[$i-1]."\t" . $ascii[$i-1]."\n" if $check;


}
# ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #
sub search_name {
my ($country, $ort) = @_;
my $dfile = $dpath."/".$country.".tab";

$ort = search_term($ort);

open (KEYD, $dfile) or die "can not open $dfile\n";

$i = 0;
while(<KEYD>){
	
	($locid[$i], $ags[$i], $name[$i], $ort[$i], $lat[$i], $lon[$i], 
	$amt[$i], $plz[$i], $vorwahl[$i],$einwohner[$i], $flaeche[$i], $kz[$i], 
	$typ[$i], $level[$i], $of[$i], $invalid[$i]) 
		= split /[\t\n]/;
	#	or print "malformatted input line:\n\t".$_."\n";
#	$i++ if  ((($plz and $plz[$i] =~ /$plz/ and $name[$i] eq $ort) or 
#	       (!$plz and $name[$i] eq $ort) or
#	       (!$ort and $plz[$i] =~ /$plz/))
    $i++ if ($name[$i] eq $ort
	       and !$invalid[$i]);
	if ($i>100) {
	   print "Abbruch der Suche nach $ort nach 100 Treffern\n",p;
	   last; }
}
	print $i . "\t" . $locid[$i-1]."\t" 
	    . $ags[$i-1]."\t". $name[$i-1]."\t" . $ascii[$i-1]."\n" if $check;


}
# ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #
sub search_distance {
my ($country, $locid,$distance) = @_;
my $dfile = $dpath."/".$country.".tab";
my $my_plz;
my ($my_lat,$my_lon);
my ($latmin,$latmax,$lonmin,$lonmax);

print "Suche nach Umkreis $distance in $dfile\n",p if $check;

search_locid($country, $locid);
return if !$lat[0] or !$lon[0];
$latmin = $lat[0] - d_lat($distance);
$latmax = $lat[0] + d_lat($distance);
$lonmin = $lon[0] - d_lon($lat[0],$distance);
$lonmax = $lon[0] + d_lon($lat[0],$distance);
$i++;
print "$latmin..$latmax / $lonmin..$lonmax\n",p if $check;
open (KEYD, "<:utf8", $dfile) or die "can not open $dfile\n";
while (<KEYD>) {

	($locid[$i], $ags[$i], $name[$i], $ort[$i], $lat[$i], $lon[$i], 
	$amt[$i], $plz[$i], $vorwahl[$i],$einwohner[$i], $flaeche[$i], $kz[$i], 
	$typ[$i], $level[$i], $of[$i], $invalid[$i]) 
		= split /[\t\n]/;
	#	or print "malformatted input line:\n\t".$_."\n",p;
	if ($lat[$i]>$latmin and $lat[$i] <$latmax 
	   and $lon[$i]>$lonmin and $lon[$i]<$lonmax) {
	   $distance[$i] = distance($lat[$0],$lon[0],$lat[$i],$lon[$i]);
	   print "$locid[$i]: $distance[$i], $ort[$i]; $lat[$i] / $lon[$i]\n",br if $check;
	   $i++ if $distance[$i] < $distance;
	}
	print "$_\n",p if $check;
	if ($i>100) {
	   print "Abbruch der Suche nach $ort nach 100 Treffern\n",p;
	   last; }
}		
}
# ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #
sub create_hierarchies {
my ($country) = @_;
my $dfile = $dpath."/".$country.".tab";
my $hfile = $dpath."/".$country."hier.sql";
my $i=0;
my $hid;
my $hlevel;
my $hof;
my $mylevel=1;
my $hier0="0\t104"."\t0" x 8;
my %hier;
my ($key,$value);
my $cpustart= (times)[0];
my $cpuend;

while ($mylevel < 9) { 
    print "pass: ".($mylevel+1);
    open (KEYD, "<:utf8", $dfile) or die "can not open $dfile\n";
    while(<KEYD>){
        ($hid,$hlevel,$hof)=/^(\d+)\t(?:[^\t]*\t){12} *(\d+)\t*(\d+)(?:\t.*$)?/;
        if($mylevel  == $hlevel-1) {
            print "$i.$mylevel:$hid:$hlevel/$hof;\n" if $check;
            $hier{$hid} = $hier{$hof}?$hier{$hof}:$hier0;
            $hier{$hid} =~ s/^\d+((\t\d+){$mylevel})\t0/$hlevel$1\t$hid/;
            print "->$hier{$hid}\n" if $check;
            $i++;
        } 
    }
    $cpuend = (times)[0];
    print ":#$i .\n";
    printf " %.3f cpu seconds<br>",($cpuend-$cpustart);
    close (KEYD);
    $mylevel++;
}

open (KEYH, ">:utf8", $hfile) or die "can not open $hfile\n";
while (($key,$value)= each %hier) {
    $value =~ s/\t0/\tnull/g;
    $value =~ s/\t/,/g;
    print KEYH "INSERT INTO geodb_hierarchies VALUES($key,$value,null,null,'3000-01-01',300500000); /* $country */\n";
}
close (KEYH);
$cpuend = (times)[0];
printf "total time: %.3f cpu seconds<p>",($cpuend-$cpustart);
}
# ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #
# arccos(sin(B_lat)*sin(A_lat)+cos(B_lat)*cos(A_lat)*cos(B_lon - A_lon))
sub distance {
my ($A_lat,$A_lon,$B_lat,$B_lon) = @_;
return ($earth*abs( acos(
    sin_deg($B_lat) * sin_deg($A_lat) + 
    cos_deg($B_lat) * cos_deg($A_lat) * cos_deg($B_lon - $A_lon))));
}
sub d_lon {
my ($lat,$distance) = @_;
return(abs(acos(
    (cos($distance/$earth) - sin_deg($lat)*sin_deg($lat)) / 
    (cos_deg($lat)*cos_deg($lat)))
   *45/atan2(1,1)));
}
sub d_lat {abs(($_[0]/$earth)*45/atan2(1,1))}
sub rad { my $pi = atan2(1,1)*4; return ($pi * $_[0] / 180);}
sub sin_deg {sin(rad($_[0]))} 
sub cos_deg {cos(rad($_[0]))} 
sub acos { atan2(sqrt(1 - $_[0] * $_[0]), $_[0] )}
# ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #
sub search_locid {
my ($country, $locid) = @_;
my $dfile = $dpath."/".$country.".tab";
my $my_plz;

print "Suche nach $locid in $dfile\n",p if $check;

open (KEYD, "<:utf8", $dfile) or die "can not open $dfile\n";

$i = 0;
while (<KEYD>) {
    last if /^$locid\t/;
}
	
	($locid[$i], $ags[$i], $name[$i], $ort[$i], $lat[$i], $lon[$i], 
	$amt[$i], $plz[$i], $vorwahl[$i],$einwohner[$i], $flaeche[$i], $kz[$i], 
	$typ[$i], $level[$i], $of[$i], $invalid[$i]) 
		= split /[\t\n]/;
	#	or print "malformatted input line:\n\t".$_."\n",p;
		
	print "$_\n",p if $check;
		
}
# ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #
sub search_locid_extra {
my ($country, $locid) = @_;
my $dfile = $dpath."/extra.sql";

print "Suche nach $locid in $dfile\n",p if $check;

open (KEYD, "<:utf8", "$dfile") or die "can not open $dfile\n";

$i = 1;
while (<KEYD>) {	
	if (/\($locid,/) {
		$extra[$i] = $_ ;
#		print $extra[$i],"\n",br;
		$i++;
	}
}		
}
# ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #
sub show_locid_extra {
my ($country, $locid) = @_;
my $ii=1;
my $dateb; # begin
my $datee; # end
my $field;
my $value;
my $lang;
my %geodb = {
'-1' => '[unbekannt]',
'0' => 'nicht vorhanden',
'1' => 'beliebig',
# Hierarchien
'100100000' => 'Erdteil',
'100200000' => 'Staat/Land',
'100300000' => 'Bundesland',
'100300000' => 'Kanton',
'100400000' => 'Regierungsbezirk',
'100500000' => 'Landkreis',
'100550000' => 'Verwaltungsgemeinschaft',
'100600000' => 'Politische Gliederung',
'100700000' => 'Gemeinde',
'100700000' => 'Ortschaft',
'100800000' => 'Postleitzahlgebiet',
# Koordinaten
'200100000' => 'WGS84 Koordinaten',
'200200000' => 'geographische Breite',
'200300000' => 'geographische Länge',
# Datum
'300100000' => 'Genaues Datum',
'300200000' => 'Auf ein Monat genaues Datum',
'300300000' => 'Auf ein Jahr genaues Datum',
'300400000' => 'Auf 10 Jahre genaues Datum',
'300450000' => 'Auf 100 Jahre genaues Datum',
'300500000' => 'Unbekanntes Datum in der Zukunft',
'300550000' => 'Unbekanntes Datum in der Vergangenheit',
# Relationen
'400100000' => 'Teil von',
'400200000' => 'Ebene',
'400300000' => 'Typ',
# Text
'500100000' => 'Name',
'500100000' => 'Ort',
'500100001' => 'ISO 3166 Alpha-2',
'500100002' => 'Sortiername',
'500100003' => 'ISO_3166_2',
'500100004' => 'Region eines Postleitzahlgebietes',
'500300000' => 'Postleitzahl',
'500500000' => 'KFZ-Kennzeichen',
'500600000' => 'Amtlicher Gemeindeschlüssel',
'500700000' => 'Verwaltungszusammenschluss',
'500700001' => 'Sortiername eines Verwaltungszusammenschlusses',
'500800000' => 'Quelle',
#Zahl
'600700000' => 'Einwohnerzahl',
'600700001' => 'Ungefähre Einwohnerzahl',
'600700002' => 'Genaue Einwohnerzahl',
'650800000' => 'Höhenangabe',
'650800001' => 'Maximale Höhe',
'650800002' => 'Minimale Höhe',
'650800003' => 'Durchschnittliche Höhe',
'650800004' => 'Höhe am Referenzpunkt mit der angegebenen loc_id',
'650800005' => 'Höhe an der angegebenen Koordinate',
};


print hr(), h2("Extra-Daten"), start_table();
print Tr(th("Feld"),th("Wert"),th("Sprache"),th("Beginn"),th("Ende"));
while ($ii < $i) {

    if ($extra[$ii] =~ /textdata/i) {
        ($locid,$field,$value,$lang,$dateb,$datee) = ($extra[$ii] =~
         /INSERT INTO geodb_textdata VALUES\((\d+),(\d+),'(.*)',(....,\d,\d),(.*,.*),(.*,.*)\);/); 
        if($lang =~ /'(..)',([01]),([01])/) {
            if    ($2==1 and $3==1) {$lang = b($1); }
            elsif ($2==1 and $3==0) {$lang = b(i($1));}
            elsif ($2==0 and $3==1) {$lang = i($1);}
            else                    {$lang = $1;}         
        } elsif ($lang eq "null,null,null") {
            $lang="";
        } 
    } elsif ($extra[$ii] =~ /geodb_coordinates/i) {
        ($locid,$field,$value,$lang,$dateb,$datee) = ($extra[$ii] =~
            /INSERT INTO geodb_coordinates VALUES\((\d+),(\d+),([0-9\.]+,[0-9\.]+),(\a*),(.*,.*),(.*,.*)\);/); 
         $lang = "" if $lang eq "null";
    } elsif ($extra[$ii] =~ /geodb_intdata/i) {
        ($locid,$field,$value,$dateb,$datee) = ($extra[$ii] =~
            /INSERT INTO geodb_coordinates VALUES\((\d+),(\d+),([0-9]+),(.*,.*),(.*,.*)\);/); 
         $lang = "";
    } elsif ($extra[$ii] =~ /geodb_floatdata/i) {
        ($locid,$field,$value,$dateb,$datee) = ($extra[$ii] =~
            /INSERT INTO geodb_coordinates VALUES\((\d+),(\d+),([0-9\.]+),(.*,.*),(.*,.*)\);/); 
         $lang = "";
    }
    $dateb="" if $dateb eq "null,null";
    $datee="" if $datee eq "'3000-01-01',300500000";
    print Tr(td($field),td($value),td($lang),td($dateb),td($datee));
    $ii++;
}
print end_table;
}
# ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #
sub show_locid {
my $my_plz;

print hr(), h2("Basis-Daten"), start_table();
print Tr(th({align=>"RIGHT"}, "loc_id:"),	th($locid[0]), 
#    td(i("<a href=\"?locid=$locid[0];c=$country;action=delete\">delete</a>")));
    td(i("delete")));
print Tr(th({align=>"RIGHT"}, "Ort:"),	th($ort[0]), td(i(edit_url($locid[0],'Ort',$ort[0]))));
print Tr(th({align=>"RIGHT"}, "lat:"),	th($lat[0]), td(i(edit_url($locid[0],'lat',$lat[0]))));
print Tr(th({align=>"RIGHT"}, "lon:"),	th($lon[0]), td(i(edit_url($locid[0],'lon',$lon[0]))));
print Tr(th({align=>"RIGHT"}, "AGS:"),	td($ags[0]), td(i(edit_url($locid[0],'AGS',$ags[0]))));
print Tr(th({align=>"RIGHT"}, "Amt:"),	td($amt[0]), td(i(edit_url($locid[0],'Amt',$amt[0])))) if $level[0]==6;
print Tr(th({align=>"RIGHT"}, "ASCII:"),	td($name[0]), td(i(edit_url($locid[0],'ASCII',$name[0]))));
print Tr(th({align=>"RIGHT"}, "Ebene:"),	td($level[0]), td(i(edit_url($locid[0],'Ebene',$level[0]))));
print Tr(th({align=>"RIGHT"}, "Einwohner:"),	td($einwohner[0]), td(i(edit_url($locid[0],'Einwohner',$einwohner[0]))));
print Tr(th({align=>"RIGHT"}, "Fläche:"),	td(
		$flaeche[0]?
				( $lat[0]?"<a href=\"?locid=$locid[0];c=$country;distance=".int(sqrt($flaeche[0])+1).
						"\">$flaeche[0] km²</a>":"$flaeche[0] km²"):""),
    td(i(edit_url($locid[0],'Fläche',$flaeche[0]))));
print Tr(th({align=>"RIGHT"}, "KZ:"),	td($kz[0]), td(i(edit_url($locid[0],'KZ',$kz[0]))));
foreach $my_plz (split /,/, $plz[0]) {
    print Tr(($plz[0] =~ /^$my_plz/)?th({align=>"RIGHT", valign=>"TOP"}, "PLZ:"):th(),    
        td($my_plz), td({valign=>"TOP"}, i(edit_url($locid[0],'PLZ',$my_plz))));
}
print Tr(th({align=>"RIGHT"}, "PLZ:"), td(), td(i(edit_url($locid[0],'PLZ',"---")))) if !$plz[0];
print Tr(th({align=>"RIGHT"}, "Teil von:"),	td(a({-href=>"?locid=$of[0];c=$country"}, 
    $of[0])), td(i(edit_url($locid[0],'of',$of[0]))));
print Tr(th({align=>"RIGHT"}, "Typ:"),	td($typ[0]), td(i(edit_url($locid[0],'Typ',$typ[0]))));
print Tr(th({align=>"RIGHT"}, "Vorwahl:"),	td($vorwahl[0]), td(i(edit_url($locid[0],'Vorwahl',$vorwahl[0]))));
print Tr(td(),td(a({-href=>"?parts=$locid[$ii];c=$country"},"Teile anzeigen") .
    " | <a href=\"?neu=$locid[0];c=$country;400100000=$locid[0];400200000=".($level[0]+1)."\">".
    "neuen Teil erstellen</a>"),td());
print end_table();

print b("Dieser Eintrag wurde als gelöscht markiert!"),p if $invalid[0];

}

# ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #
sub show_changes{
my ($locid) = @_;
my $ii=0;
my $imax;
my @changes;

open (HTMLFILE, $htmlfile) or die "can not open $htmlfile\n";
while (<HTMLFILE>) {
    $changes[$ii] = $_;
    $ii++ if !$locid or /locid=$locid;/;
}
close (HTMLFILE);

$imax=$ii;
if ($ii) {
    print hr(), h2("Änderungen");
    print "<table>";
    print Tr(th(["loc_id","Name","Feld","alt","neu","Datum","&nbsp;"]));
    while ($ii>0) {
        print $changes[--$ii];
	last if($imax - $ii > 100);
    }
    print "</table>";
    print b("100 von $imax Änderungen"),p
	if($imax - $ii > 100) ;
;
}
}
# ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #
sub search_parts {
my ($country, $locid) = @_;
my $dfile = $dpath."/".$country.".tab";

open (KEYD, "<:utf8", $dfile) or die "can not open $dfile\n";
print "Suche nach Teilen von ", a({-href=>"?locid=$locid;c=$country"},$locid), p;
$i = 0;
while (<KEYD>) {
    if(/[\t]$locid[\t\n
]/) {
	($locid[$i], $ags[$i], $name[$i], $ort[$i], $lat[$i], $lon[$i], 
	$amt[$i], $plz[$i], $vorwahl[$i],$einwohner[$i], $flaeche[$i], $kz[$i], 
	$typ[$i], $level[$i], $of[$i], $invalid[$i]) 
		  = split /[\t\n]/;
	#	  or print "malformatted input line:\n\t".$_."\n"; 
		  print $_ if $check;
		  print "\t...$i:>$of[$i]<\n",br if $check;
    }
#    $i++ if ($of[$i] and (("\t".$of[$i]."\t") =~ /[\t]$locid[\t]/));
    $i++ if ($of[$i] == $locid and !$invalid[$i]);
}
print "Es gibt keine Einträge unter der ".
    a({-href=>"?locid=$locid;c=$country"},$locid), p if $i==0;


}
# ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #


# ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #
# ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #
sub search_term {
my ($my_expr) = @_;
print "search_my_expr: $my_expr\n",p if $check>1;
#$my_expr=decode_utf8($my_expr) if is_utf8($my_expr);
#print "search_my_expr: $my_expr\n",p if $check>1;
return '' if !$my_expr;
$my_expr =~ tr/a-zäöüáàâãåéèêëíìïïóòôõçñ/A-ZÄÖÜAAAAAEEEEIIIIOOOOCN/;
print "search_my_expr: $my_expr\n",p if $check>1;
$my_expr =~ tr/ÀÁÂÃÅÈÉÊËÌÍÎÏÒÓÔÕÇÑ/AAAAEEEEIIIIOOOOCN/;
print "search_my_expr: $my_expr\n",p if $check>1;
$my_expr =~ s/Ä/AE/g;
$my_expr =~ s/Ö/OE/g;
$my_expr =~ s/Ü/UE/g;
$my_expr =~ s/(SS|ß|ßS|SSS)/SS/g;
print "search_my_expr: $my_expr\n",p if $check>1;
$my_expr =~ s/\./\\./g;
$my_expr =~ s/\*/.*/g;
$my_expr =~ tr/-A-Z0-9 \.\*/-/cs;
$my_expr =~ s/^[- ]*//;
$my_expr =~ s/[- ]*$//;
#$my_expr =~ s/^(.{,40})/$1/;
print "search_my_expr: $my_expr\n",p if $check>1;
return $my_expr;
}
# ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #
sub access_log {

my	$ltime	= ''; # log time
my	$lip	= ''; # log ip
my	$ldom	= ''; # log domain
my	$lday	= time() - 24*60*60;
my	$rip	= remote_host();
my	$dummy;
my	$lurl	= url($locid[0],-query => 1);

$lurl = $lurl =~ s/;[^;]*=;/;/g;



print $lfile."\n" if $check>9;
print time() . "\t$rip\t" . user_agent() . "\t" . referer() . "\n" if $check>9;

open (LOGFILE, ">> $lfile") or die "access logfile not available: $!\n";
print LOGFILE time() . "\t$rip\t".
	$lurl . "\t". query_string . "\t" . referer() . "\t" . user_agent() . "\n";
close (LOGFILE);

}
# C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #
sub init {
if(param('debug')) {
	$check = param('debug');
	print "check level = $check\n",p if $check>99;

}

if (param("hu")) {
    $hu = param("hu");
    $ckhu = cookie(-name =>'hu', -value=>$hu);
}   else {
    $hu = cookie ("hu"); }
    
if (param("he")) {
    $he = param("he");
    $ckhe = cookie(-name =>'he', -value=>$he);
}   else {
    $he = cookie ("he"); }

$he =~ s/(?:.* *)([a-zA-Z0-9\-\.\_]+@[a-zA-Z0-9\-_\.]*\.[a-zA-Z]+$)/$1/;
$ckhu = "" if !$he;


#<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">

$html_style =
'<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
          "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<meta name="revisit-after" content="333 days">
<title>opengeodb</title>
<base target="_top">
<link rel="stylesheet" type="text/css" href="../styles/styles.css" media="screen">
<link rel="stylesheet" type="text/css" href="../styles/druck.css" media="print">
</head>';
$html_header='
<body bgcolor="#ffffff" background="../img/home2.jpg">

<!-- config errmsg="Navigation nicht anzeigbar!"-->
<!-- include virtual="../navigation/navi.txt"-->
<!--adfc-logo.txt-->
<div style="position:relative; top:0px;left:0px;">
<table cellpadding=0 cellspacing=0 border=0 width="100%">
<tr>
<td height=105 valign="bottom" style="background-image:url(http://www.fa-technik.adfc.de/img/logo_neu2.gif);background-repeat:no-repeat;">
<a href="http://www.fa-technik.adfc.de/index.html"><img src="http://www.fa-technik.adfc.de/img/fa.gif" alt="Fachausschuss Technik" width=785 height=105 border=0></a></td>
</tr>
<tr><td><img src="http://www.fa-technik.adfc.de/img/onebyone.gif" width=32 height="10" alt="">
<span style="font-size:9px;">
<a href="http://www.adfc.de/" target="_blank">ADFC</a>&nbsp;&gt;&gt;&nbsp;
<a href="http://www.fa-technik.adfc.de/">FA Technik</a> &gt;&gt;&nbsp;
<a href="http://www.fa-technik.adfc.de/Ratgeber/">Ratgeber</a>&nbsp;&gt;&gt;&nbsp;
<a href="http://www.fa-technik.adfc.de/Codierung/">Codierung</a>&nbsp;&gt;&gt;&nbsp;
</span></td></tr>
</table>
</div>

<div style="margin-left:32px;margin-right:10px;">
<table width="98%">
<tr>
<td class="ueberschrift">opengeodb</td>
</tr>
</table>
';
$html_footer='
</div>
<hr>
<address><a href="&#x004D;ailto&#x003A;code&#x0040;adfc-bw&#x002E;de">Martin Trautmann</a></address>
<p>

<table>
<tr>
<td>&nbsp;</td>
<td>
<div class="druck">
<img src="http://www.fa-technik.adfc.de/img/onebyone.gif" width=630 height=1 alt="">
</div>
<div class="nurdruck">
<hr>
<p><strong>Allgemeiner Deutscher Fahrrad-Club, Fachausschuss Technik - http://www.fa-technik.adfc.de
<!--#echo var="DOCUMENT_URI" --></strong></p>
</div>
</td>
</tr>
</table>
';
}
# ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #
sub report_error {
my $error = cgi_error;
    if ($error) {
	print header(-status=>$error),
	      start_html('Problems'),
              h2('Request not processed'),
	      strong($error);
        exit 0;
	}
}
# ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #
